# -*- coding: utf-8 -*-

import numpy as np
from sklearn.ensemble import RandomForestRegressor
import pandas as pd
from sklearn import linear_model
from chainer import Chain, optimizers, Variable
import chainer.functions as F
import chainer.links as L
from sklearn.metrics import mean_squared_error

#　y_trainは，学習させるデータの数，y_testは学習させた結果をチェックする数
y_train = []
y_test = []
compare_old=pd.DataFrame()
error_new=pd.DataFrame()

#　訓練するデータファイルの読み込み
n_data=input('How many traningdata do you have? \n')
n_ave=input('How many average do you want? \n')

read_data= pd.read_csv("creep_data.csv", encoding="cp932")
data_row_n = len(read_data)
data_row = read_data[:int(data_row_n)]
data_para = len(read_data.columns) -1

x_data = data_row.iloc[:,0:int(data_para)]
y_data = data_row.iloc[:,int(data_para)]
x_data_mean = x_data.mean(axis=0)
x_data_std = x_data.std(axis=0)
y_data_mean = y_data.mean()
y_data_std = y_data.std()


i=1
para_m_old2=[0]

while i <= int(n_data):
    read_data= pd.read_csv("trainingdata_{}.csv".format(i), encoding="cp932")
    test_data= pd.read_csv("testdata_{}.csv".format(i), encoding="cp932")
    print ('Number of column in read CSV file:%d' % len(read_data.columns))
    print ('Number of row in read CSV file:%d' % len(read_data))
    print ('-------------------------------------------')

   #　訓練に使うデータ数を指定
    train_row = len(read_data)
    train_data = read_data[:int(train_row)]
    train_row= len(train_data)
    test_row=len(test_data)

    #　訓練，テスト用データの読み込み
    train_para = len(read_data.columns) -1
    x_train = train_data.iloc[:,0:int(train_para)]
    x_test = test_data.iloc[:,0:int(train_para)]
    y_train = train_data.iloc[:,int(train_para)]
    y_test = test_data.iloc[:,int(train_para)]
    
    compare_exp=x_test

    W=x_test.loc[:,"Water"]
    WC=x_test.loc[:,"W/C"]
    RH=x_test.loc[:,"RH"]
    fc=x_test.loc[:,"Strength"]
    VS=x_test.loc[:,"V/S"]
    t_load=x_test.loc[:,"t_load"]
    time=x_test.loc[:,"Time"]
    temp=x_test.loc[:,"Temp"]
    
    t_load_eff=t_load*np.exp(13.65-4000/(273+temp))
    time_eff=time*np.exp(13.65-4000/(273+temp))

    CW=1/WC
    f_ct=1.11*t_load/(4.5+0.95*t_load)*(-20+30*CW)
    creep_t=(4*W*(1-RH/100)+350)/(12+f_ct)*np.log(time_eff+1)
    f_ctt=1.11*(t_load_eff)/(4.5+0.95*(t_load_eff))*(-20+30*CW)

    E_inv=[]

    ii=0

    while ii <= int(test_row)-1:
        if f_ctt[ii] < 30:
            E_inv.append(1/((2.2+(f_ctt[ii]-18)/20))*10**2)
        elif 30 <= f_ctt[ii] < 40:
            E_inv.append(1/((2.8+(f_ctt[ii]-30)/33))*10**2)
        elif 40 <= f_ctt[ii] < 70:
            E_inv.append(1/((3.1+(f_ctt[ii]-40)/50))*10**2)
        elif 70 <= f_ctt[ii]:
            E_inv.append(1/((3.7+(f_ctt[ii]-70)/100))*10**2)

        ii=ii+1

    J_creep=creep_t+E_inv


    ## 重回帰
    linear_regression = linear_model.LinearRegression(fit_intercept=False, normalize = True)
    result_l = linear_regression.fit(x_train,y_train)
    para_imp = result_l.coef_
    para_co = pd.DataFrame(para_imp, index = train_data.columns[0:int(train_para)])
    para_co.to_csv('creep_parameter_coff.csv')
    para_int = result_l.intercept_
    x_train.corr().to_csv('correlation.csv')
    linear_result = para_imp*x_test
    sum_linear = np.sum(linear_result, axis=1)

    compare = pd.DataFrame(compare_exp)
    compare['実データ'] = y_test
    compare['土木学会式'] = J_creep
    compare['重回帰予測'] = sum_linear

    exp_data=compare.loc[:,'実データ']
    linear_r=compare.loc[:,'重回帰予測']
    JSCE_r=compare.loc[:,'土木学会式']

    x_test = test_data.iloc[:,0:int(train_para)]
    
    para_m_old=[0]


    x_train_n = x_train - x_data_mean
    x_train_n /= x_data_std
    y_train_n = y_train - y_data_mean
    y_train_n /= y_data_std

    x_test_n = x_test - x_data_mean
    x_test_n /= x_data_std
    y_test_n = y_test - y_data_mean
    y_test_n /= y_data_std

    k=1
    while k <=int(n_ave):
        forest = RandomForestRegressor(n_estimators=100)
        result_f = forest.fit(x_train_n,y_train_n)
        para_imp = result_f.feature_importances_
        para_m = pd.DataFrame(para_imp, index = train_data.columns[0:int(train_para)])
        para_m_sum= para_m + para_m_old
        para_m_ave=para_m_sum/float(k)
        para_m_old=para_m_sum
        predict_f = forest.predict(x_test_n)
        #score_f_train = forest.score(x_train, y_train)
        #score_f_test = forest.score(x_test, y_test)
        #
        # ニューラルネット学習，予測
        # Chainerの設定
        # ここを参照　https://www.sejuku.net/blog/48241
        class Mychain(Chain):
        #ここでは，3つの中間層
            def __init__(self, n_inp =train_para, n_hid1=20, n_hid2=10, n_hid3=15, n_out=1):
                super(Mychain, self).__init__(
                l1 = L.Linear(n_inp, n_hid1),
        #        l2 = L.Linear(n_hid1, n_hid2),
        #       l3 = L.Linear(n_hid2, n_hid3),
                l4 = L.Linear(n_hid1, n_out)
                )
        
            def __call__(self, x):
                hid1 = F.relu(self.l1(x))
#                hid2 = F.relu(self.l2(hid1))
        #       hid3 = F.relu(self.l3(hid2))
                return self.l4(hid1)
        #
        model = Mychain()
        # 
        ## ニューラルネットの学習方法をAdamに設定
        optimizer = optimizers.Adam()
        optimizer.setup(model)
        #
        ### dataをVariableに変換
        x_train_np = np.array(x_train_n, dtype=np.float32)
        train_x_variable = Variable(x_train_np)
        y_train_np = np.array(y_train_n, dtype=np.float32)
        y_train_np1 = y_train_np.reshape(int(train_row),1)
        train_y_variable = Variable(y_train_np1)
        #
        x_test_np = np.array(x_test_n, dtype=np.float32)
        test_x_variable = Variable(x_test_np)
        y_test_np = np.array(y_test_n, dtype=np.float32)
        #print(test_row)
        #print(y_test_np)
        y_test_np1 = y_test_np.reshape(int(test_row),1)
        test_y_variable = Variable(y_test_np1)
        #
        ## 学習の様子を記録するために、リストを作っておきます。
        loss_log = []
        loss_test_log = []
        ## 学習ステップです。ここでは1000回行います。
        for epoch in range(1000):
            
        # パラメータの勾配を初期化
            model.cleargrads()
        #    # フォワードプロパゲーション
            predict_x = model(train_x_variable)
        #    # 損失関数を計算
            loss = F.mean_squared_error(predict_x, train_y_variable)
        #    # 損失関数の値を元に、パラメータの更新量を計算
            loss.backward()
        #    # パラメータを更新
            optimizer.update()
        # 
            predict_test_x = model(test_x_variable)
        #    # 損失関数を計算
            loss_test = F.mean_squared_error(predict_test_x, test_y_variable)
            loss_test.backward()
        #    # 損失関数の値を保存しておきましょう。後で確認できます。
            loss_log.append(loss.data)
            loss_test_log.append(loss_test.data)
        ##
    #    plt.plot(loss_log, label="train_loss_{}".format(i))
    #    plt.plot(loss_test_log, label="test_loss_{}".format(i))
        #    plt.legend()
        #    plt.xlabel("epoch")
        #    plt.ylabel("loss")
        #
        chain_test = predict_test_x.data

        predict_f *= y_data_std
        predict_f += y_data_mean

        chain_test *= y_data_std
        chain_test += y_data_mean
        #
        #
        compare['RF予測_{}'.format(k)]=predict_f
        compare['NN予測_{}'.format(k)]=chain_test
        
        k=1+k

    compare_new=compare_old.append(compare)
    compare_old = compare_new

    para_m_sum2= para_m_ave + para_m_old2
    para_m_ave2=para_m_sum2/float(i)
    para_m_old2=para_m_sum2
        
    print(i)
    i=i+1


exp_data=compare_new.loc[:,'実データ']
linear_r=compare_new.loc[:,'重回帰予測']
JSCE_r=compare_new.loc[:,'土木学会式']

j=1
randam_old=0
chainer_old=0

while j<=int(n_ave):
    random_r=compare_new.loc[:,'RF予測_{}'.format(j)]
    chainer_r=compare_new.loc[:,'NN予測_{}'.format(j)]
    
    randam_sum=random_r+randam_old
    chainer_sum=chainer_r+chainer_old
    randam_old=randam_sum
    chainer_old=chainer_sum
    
    error=pd.Series([np.sqrt(mean_squared_error(exp_data, random_r)),
                     np.sqrt(mean_squared_error(exp_data, chainer_r)),
                     np.sqrt(mean_squared_error(exp_data, linear_r)),
                     np.sqrt(mean_squared_error(exp_data, JSCE_r))],
                     index=['RF', 'NN', '重回帰', '示方書'])
    error_ave=pd.Series([np.sqrt(mean_squared_error(exp_data, randam_sum/float(j))),
                     np.sqrt(mean_squared_error(exp_data, chainer_sum/float(j))),],
                     index=['RF', 'NN'])
    
    error_new['{}回目'.format(j)]=error
    error_new['平均{}'.format(j)]=error_ave

    j=j+1

randam_ave=randam_sum/float(n_ave)
chainer_ave=chainer_sum/float(n_ave)

compare_new['NN予測_平均']=chainer_ave
compare_new['RF予測_平均']=randam_ave

compare_new.to_csv('compare_creep.csv')

para_m_ave2.to_csv('creep_parameter_imp.csv')
error_new.to_csv('error_creep.csv')
 
